import { globalStyle, globalLookup, globalSetting } from '../global';

const yOffsetUpdate = (pstate, nextOffsetYFn) => {
    let nextOffsetY = nextOffsetYFn();
    const { width, xOffset, xScale, time, sidebarWidth } = pstate;

    nextOffsetY = nextOffsetY;

    // 当前所有信号的高度之和
    const currentRenderHeight = globalLookup.currentWires.size * pstate.yStep;
    
    // 当前有效的画布高度
    const canvasHeight = pstate.height - pstate.topBarHeight - pstate.botBarHeight;

    if (currentRenderHeight < canvasHeight) {
        // 如果当前的信号高度小于画布的高度，则取消本次渲染
        return false;
    }

    const maxOffsetY = Math.max(-20, currentRenderHeight - canvasHeight);
    nextOffsetY = Math.min(nextOffsetY, maxOffsetY);

    const minOffsetY = -20;
    nextOffsetY = Math.max(nextOffsetY, minOffsetY);
    
    console.log(nextOffsetY);
    
    
    pstate.oldYOffset = pstate.yOffset;
    pstate.yOffset = nextOffsetY;

    // 这玩意儿初始设置 -20 的偏移，当作 padding-top
    globalStyle.yOffset = nextOffsetY + 20;
    return true;
};

export default yOffsetUpdate;